#include <iostream>
#include <vector>
#include <queue>
using namespace std;
#define PII pair<int,int>

vector <PII> nodes[500000];  // n[i] -> j, cost
vector <int> hiji[500000];  // person from i-th group
int N, M, K;
int groups[40000]; // num of people in group
int sums[40000]; // sums for group i
void BFS(PII);
//bool used[500000];

int main()
{
	int i, x, y, c;
	scanf("%d%d%d", &N, &M, &K);
	for (i = 0; i < M; i++)
	{
		scanf("%d%d%d", &x, &y, &c);
		nodes[x-1].push_back(PII(y-1, c));
	}
	for (i = 0; i < K; i++)
	{
		scanf("%d", &groups[i]);
		for (x = 0; x < groups[i]; x++)
		{
			scanf("%d", &y);
			hiji[y-1].push_back(i);
		}
	}
	/*
	for (i = 0; i < N; i++)
	{
		cout << i << endl;
		for (int j = 0;j < nodes[i].size(); j++)
		 cout << nodes[i][j].first << " " << nodes[i][j].second << endl;
		cout << endl;
	}*/
	//for (i=0;i < hiji[4].size();i++)
	//cout << hiji[4][i] << endl;
	
	BFS(PII(0,0));
	
	for (i = 0; i < K; i++)
	 cout << sums[i] << endl;
	
	system("pause");
	return 0;
}

void BFS(PII v)
{
	queue <PII> q;	// vertex + cost to enter it
	q.push(v);
	int v_num, v_cost;
	while (!q.empty())
	{
		v = q.front();
		q.pop();
		v_num = v.first;
		v_cost = v.second;
		//cout << v_num << " " << v_cost << endl;
		
		if (nodes[v_num].empty()) // hija
		{
			int gr;
			while (!hiji[v_num].empty())
			{
				gr = hiji[v_num].back();
				hiji[v_num].pop_back();
				if (groups[gr] > 1) sums[gr] += v_cost / 2;
				else sums[gr] += v_cost;
				
				groups[gr]--;
			}
		}
		
		// increase cost for all non-0 groups
		for (int i = 0; i < K; i++)
		 if (groups[i] > 1) sums[i] += v_cost / 2;
		 else if (groups[i] > 0) sums[i] += v_cost;
		
		while (!nodes[v_num].empty())
		{
			q.push(nodes[v_num].back());
			nodes[v_num].pop_back();
		}
	}
}
